package com.hopeland.androidpc.example.hf;

import com.hopeland.androidpc.example.R;
import com.hopeland.androidpc.example.uhf.UHFBaseActivity;
import com.clou.uhf.G3Lib.CLReader;
import com.clou.uhf.G3Lib.ClouInterface.IAsynchronousMessage;
import com.clou.uhf.G3Lib.Protocol.Tag_Model;
import android.content.Intent;
import android.os.Bundle;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;

public class HFMain extends UHFBaseActivity implements IAsynchronousMessage {

	private final int MSG_SHOW_HF_VER = MSG_USER_BEG + 1;
	
	@Override
	protected void msgProcess(Message msg) {
		switch (msg.what) {
		case MSG_SHOW_HF_VER:
			if (msg.obj != null)
				ShowTip((String) msg.obj);
			break;
		default:
			break;
		}
		super.msgProcess(msg);
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		this.setContentView(R.layout.hf_main);
		try {
			getWindow().setFlags(
					WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON,
					WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
		} catch (Exception ex) {
			Log.d("Debug", "The initialization of abnormal:" + ex.getMessage());
		}	

		showCustomBar(getString(R.string.btn_MainMenu_HF),
				getString(R.string.str_back), null,
				R.drawable.left, 0,
				new View.OnClickListener() {
					@Override
					public void onClick(View v) {
						Back(v);
					}
				},
				null
		);
	}

	/**
	 * ISO15693
	 */
	public void OpenISO15693Activity(View v) {
		Intent intent = new Intent();
		intent.setClass(HFMain.this, ReadISO15693Activity.class);
		startActivity(intent);
	}

	/**
	 * ISO14443A
	 */
	public void OpenISO14443AActivity(View v) {
		Intent intent = new Intent();
		intent.setClass(HFMain.this, ReadISO14443Activity.class);
		startActivity(intent);
		// ShowMsg("Not open��", null);
	}

	/**
	 * Mifare
	 */
	public void OpenMifareActivity(View v) {
		Intent intent = new Intent();
		intent.setClass(HFMain.this, ReadMifareActivity.class);
		startActivity(intent);
	}

	/**
	 * Verson
	 */
	public void OpenVersionActivity(View v) {
		if (isFastClick()) {
			return;
		}
		//
		new Thread() {
			@Override
			public void run() {
				sendMessage(MSG_SHOW_WAIT,
						getString(R.string.str_please_waitting));
				String vStr = "- Version: ";
				try {
					vStr += CLReader._HF.GetReaderInformation(ConnID);
				}catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					vStr += "null";
				}
				sendMessage(MSG_SHOW_HF_VER, vStr);
				sendMessage(MSG_HIDE_WAIT, null);
			};
		}.start();
	}

	// 返回
	public void Back(View v) {
		finish();
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
	}

	@Override
	protected void onPause() {
		super.onPause();
	}

	@Override
	protected void onResume() {
		super.onResume();
	}

	@Override
	public void OutPutTags(Tag_Model model) {

	}

	@Override
	public void GPIControlMsg(int arg0, int arg1, int arg2) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void OutPutTagsOver() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void PortClosing(String arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void PortConnecting(String arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void WriteDebugMsg(String arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void WriteLog(String arg0) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void OutPutScanData(byte[] scandata) {
		// TODO Auto-generated method stub
		//System.out.println(msg);
	}

}
