package com.hopeland.androidpc.example.hf;

import com.clou.uhf.G3Lib.CLReader;
import com.clou.uhf.G3Lib.ClouInterface.IAsynchronousMessage;
import com.clou.uhf.G3Lib.Protocol.Tag_Model;
import com.hopeland.androidpc.example.R;
import com.hopeland.androidpc.example.uhf.UHFBaseActivity;

import android.content.res.Configuration;
import android.os.Bundle;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Spinner;

public class ReadISO14443Activity extends UHFBaseActivity implements
		IAsynchronousMessage {

	private Spinner sp_iso14443a_Model = null;
	private EditText tb_iso14443a_Uid = null;
	private Spinner sp_iso14443a_Block = null;
	private EditText tb_iso14443a_Data = null;
	private EditText tb_iso14443a_apdu = null;

	

	static final int MSG_UPDATE_UID = MSG_USER_BEG + 1;

	@Override
	protected void msgProcess(Message msg) {
		switch (msg.what) {
		case MSG_UPDATE_UID:
			ShowUID(msg.obj.toString()); // ˢ���б�
			break;
		default:
			super.msgProcess(msg);
			break;
		}
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		this.setContentView(R.layout.hf_iso14443a);
		ChangeLayout(getResources().getConfiguration());
		try {
			getWindow().setFlags(
					WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON,
					WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
		} catch (Exception ex) {
			Log.d("Debug", "The initialization of abnormal:" + ex.getMessage());
		}

		showCustomBar(getString(R.string.btn_HFMenu_ISO14443A),
				getString(R.string.str_back), null,
				R.drawable.left, 0,
				new View.OnClickListener() {
					@Override
					public void onClick(View v) {
						Back(v);
					}
				},
				null
		);
	}

	private void ChangeLayout(Configuration newConfig) {
		LinearLayout main = (LinearLayout)findViewById(R.id.view_split_main);
		LinearLayout left = (LinearLayout)findViewById(R.id.view_split_left);
		LinearLayout right = (LinearLayout)findViewById(R.id.view_split_right);

		if (newConfig.orientation == Configuration.ORIENTATION_LANDSCAPE) { //当前屏幕为横屏
			main.setOrientation(LinearLayout.HORIZONTAL);

			LinearLayout.LayoutParams leftParam = new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.WRAP_CONTENT, (float) 0.5);
			LinearLayout.LayoutParams rightParam = new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.MATCH_PARENT, (float) 0.5);

			leftParam.setMargins(0, 0, 10, 0);
			rightParam.setMargins(10, 0, 0, 0);

			left.setLayoutParams(leftParam);
			right.setLayoutParams(rightParam);

		} else { // 当前屏幕为竖屏
			main.setOrientation(LinearLayout.VERTICAL);

			LinearLayout.LayoutParams leftParam = new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
			LinearLayout.LayoutParams rightParam = (new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));

			leftParam.setMargins(0, 0, 0, 0);
			rightParam.setMargins(0, 0, 0, 0);

			left.setLayoutParams(leftParam);
			right.setLayoutParams(rightParam);
		}

	}

	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
		ChangeLayout(newConfig);
	}
	// 扫描标签
	public void ReadISO4443A(View v) {
		//
		tb_iso14443a_Uid.setText("");
		String setParam = "IDEL";
		if (sp_iso14443a_Model != null) {
			setParam = sp_iso14443a_Model.getSelectedItem().toString();
		}
		if (setParam.equals("ALL")) {
			setParam = "52";
		} else {
			setParam = "26";
		}
		CLReader._HF.GetISO14443ASN(ConnID,"0", setParam);
	}

	/*
	 * UID
	 */
	public void ShowUID(String uid) {
		tb_iso14443a_Uid.setText(uid);
	}

	// Halt
	public void HaltISO14443A(View v) {
		String data = CLReader._HF.HaltISO14443A(ConnID);
		ShowMsg(data, null);
	}

	// Reset
	public void ResetISO14443A(View v) {
		String setParam = "0";
		String data = CLReader._HF.ResetISO14443A(ConnID,setParam);
		ShowMsg(data, null);
	}

	// RATS
	public void ReadIso14443aRATS(View v) {
		//
		tb_iso14443a_Data.setText("");
		String setParam = "0";
		if (sp_iso14443a_Block != null) {
			setParam = sp_iso14443a_Block.getSelectedItem().toString();
		}
		String data = CLReader._HF.RATSiso14443a(ConnID,setParam);
		//
		if (data.equals("")) {
			return;
		}
		if (data.contains("|")) {
			ShowMsg(data, null);
		} else {
			tb_iso14443a_Data.setText(data.substring(8, data.length()));
		}
	}

	// APDU
	public void APDU(View v) {
		//
		String param = "00 84 00 00 08";
		if (tb_iso14443a_apdu != null) {
			param = tb_iso14443a_apdu.getText().toString();
		}
		String data = CLReader._HF.APDUiso14443a(ConnID,param);
		if (data.equals("")) {
			return;
		}
		if (data.contains("|")) {
			ShowMsg(data, null);
		} else {
			ShowMsg(data.substring(8, data.length()), null);
		}
	}

	// Deselect
	public void Deselect(View v) {
		String data = CLReader._HF.DeselctISO14443A(ConnID);
		ShowMsg(data, null);
	}

	// back
	public void Back(View v) {
		ReadISO14443Activity.this.finish();
	}

	protected void Init() {
		sp_iso14443a_Model = (Spinner) this
				.findViewById(R.id.sp_iso14443a_Model);
		tb_iso14443a_Uid = (EditText) this
				.findViewById(R.id.tb_iso14443a_Uid);
		sp_iso14443a_Block = (Spinner) this
				.findViewById(R.id.sp_iso14443a_Block);
		tb_iso14443a_Data = (EditText) this
				.findViewById(R.id.tb_iso14443a_Data);
		tb_iso14443a_apdu = (EditText) this
				.findViewById(R.id.tb_iso14443a_apdu);
		tb_iso14443a_apdu.setText("00 84 00 00 08");
		//
		CLReader.HP_CONNECT.get(ConnID).myLog = this;
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
	}

	@Override
	protected void onPause() {
		super.onPause();
	}

	@Override
	protected void onResume() {
		super.onResume();
		Init();
	}

	@Override
	public void OutPutTags(Tag_Model model) {
		try {
			sendMessage(MSG_UPDATE_UID, model._EPC);
		} catch (Exception ex) {
			Log.d("Debug", "Read the tag serial number exception:" + ex.getMessage());
		}
	}

	@Override
	public void GPIControlMsg(int arg0, int arg1, int arg2) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void OutPutTagsOver() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void PortClosing(String arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void PortConnecting(String arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void WriteDebugMsg(String arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void WriteLog(String arg0) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void OutPutScanData(byte[] scandata) {
		// TODO Auto-generated method stub
	}

}
