package com.hopeland.androidpc.example.uhf;

import java.io.File;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import com.clou.uhf.G3Lib.Enumeration.eReadType;
import com.hopeland.androidpc.example.PublicData;
import com.hopeland.androidpc.example.R;
import com.clou.uhf.G3Lib.CLReader;
import com.clou.uhf.G3Lib.ClouInterface.IAsynchronousMessage;
import com.clou.uhf.G3Lib.Helper.Helper_ThreadPool;
import com.clou.uhf.G3Lib.Protocol.Tag_Model;
import android.media.*;
import android.os.Bundle;
import android.os.Message;
import android.util.Log;
import android.view.*;
import android.widget.*;

/**
 * @author RFID_lx 读标签窗体
 */
public class ReadEPCActivity extends UHFBaseActivity implements
		IAsynchronousMessage {

	private ListView listView = null; // 数据列表对象
	private SimpleAdapter sa = null;
	private Button btn_Read = null;
	private TextView tv_TitleTagID = null;
	private TextView tv_TitleTagCount = null;
	private TextView lb_ReadTime = null;
	private TextView lb_ReadSpeed = null;
	private TextView lb_TagCount = null;
	private Spinner sp_ReadType = null;

	private int readTime = 0;
	private int lastReadCount = 0;
	private int totalReadCount = 0; // 总读取次数
	private int speed = 0; // 读取速度
	private static int _ReadType = 0; // 0 为读EPC，1 为读TID
	private static String _NowReadParam = _NowAntennaNo + "|1"; // 读标签参数
	private HashMap<String, Tag_Model> hmList = new HashMap<String, Tag_Model>();
	private Object hmList_Lock = new Object();
	private Boolean IsFlushList = true; // 是否刷列表
	private Object beep_Lock = new Object();
	ToneGenerator toneGenerator = new ToneGenerator(AudioManager.STREAM_SYSTEM,
			ToneGenerator.MAX_VOLUME);

	private final int MSG_RESULT_READ = MSG_USER_BEG + 1; // 常量读
	private final int MSG_FLUSH_READTIME = MSG_USER_BEG + 2;

	final String FILE_NAME = "/mnt/sdcard/UHF_Read_Result.csv";
	private  boolean bSaveResult = false;

	private  boolean isbusy=false;

	@Override
	protected void msgProcess(Message msg) {
		switch (msg.what) {
			case MSG_RESULT_READ:
				ShowList(); // 刷新列表
				break;
			case MSG_FLUSH_READTIME:
				if (lb_ReadTime != null) { // 刷新读取时间
					readTime++;
					lb_ReadTime.setText("Time:" + readTime + "S");
				}
				break;
			default:
				super.msgProcess(msg);
				break;
		}
	}

	// 读功能
	public void Read(View v) {
		if(isbusy)
		{
			return;
		}
		isbusy = true;
		Button btnRead = (Button) v;
		String controlText = btnRead.getText().toString();
		deleteFile(FILE_NAME);
		if (controlText.equals(getString(R.string.btn_read))) {
			PingPong_Read();
			btnRead.setText(getString(R.string.btn_read_stop));
			sp_ReadType.setEnabled(false);
		} else {
			Pingpong_Stop();
			btnRead.setText(getString(R.string.btn_read));
			sp_ReadType.setEnabled(true);
			write("Data,Count\r\n");
			SaveData();

		}
		isbusy = false;

	}

	@Override
	public boolean deleteFile(String filePath) {
		File file = new File(filePath);
		if (file.isFile() && file.exists()) {
			return file.delete();
		}
		return false;
	}

	// 间歇性读
	public void PingPong_Read() {
		Clear(null);
		Helper_ThreadPool.ThreadPool_StartSingle(new Runnable() {
			@Override
			public void run() {
				try {
					String rt = "";
					if (PublicData._IsCommand6Cor6B.equals("6C")) {// 读6C标签
						CLReader.Read_EPC(ConnID,_NowReadParam);
						//GetEPC_6C();
					} else {// 读6B标签
						CLReader.Get6B(ConnID,_NowAntennaNo + "|1" + "|1"
								+ "|" + "1,000F");
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	//6C,Read tag
	private  int GetEPC_6C()
	{
		int ret=-1;
		String text = tv_TitleTagID.getText().toString();
		if(text.equals("EPC")) {
			ret = CLReader._Tag6C.GetEPC(ConnID,_NowAntennaNo, eReadType.Inventory);
		}
		else if(text.equals("TID"))
		{
			ret = CLReader._Tag6C.GetEPC_TID(ConnID,_NowAntennaNo, eReadType.Inventory);
		}
		else if(text.equals("UserData"))
		{
			ret = CLReader._Tag6C.GetEPC_TID_UserData(ConnID,_NowAntennaNo, eReadType.Inventory,0,6);
		}
		return  ret;
	}

	// 停止读
	public void Pingpong_Stop() {
		try {
			CLReader._Config.Stop(ConnID);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void Clear(View v) {
		totalReadCount = 0;
		readTime = 0;
		hmList.clear();
		ShowList();
	}

	// 返回主页
	public void Back(View v) {
		if (btn_Read.getText().toString()
				.equals(getString(R.string.btn_read_stop))) {
			ShowMsg(getString(R.string.uhf_please_stop), null);
			return;
		}
		ReadEPCActivity.this.finish();
	}

	//初始化
	protected void Init() {
		try {
			_NowReadParam = _NowAntennaNo + "|1";
			Thread.sleep(20);
			try {
				CLReader._Config.Stop(ConnID);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			Thread.sleep(20);
			super.UHF_SetTagUpdateParam(); // 设置标签重复上传时间为20ms
		} catch (Exception ee) {
		}

		//刷新线程
		Refush();

		listView = (ListView) this.findViewById(R.id.lv_Main);
		tv_TitleTagID = (TextView) findViewById(R.id.tv_TitleTagID);
		tv_TitleTagCount = (TextView) findViewById(R.id.tv_TitleTagCount);
		lb_ReadTime = (TextView) findViewById(R.id.lb_ReadTime);
		lb_ReadSpeed = (TextView) findViewById(R.id.lb_ReadSpeed);
		lb_TagCount = (TextView) findViewById(R.id.lb_TagCount);
		btn_Read = (Button) findViewById(R.id.btn_Read);
		btn_Read.setText(getString(R.string.btn_read));
		sp_ReadType = (Spinner) findViewById(R.id.sp_ReadType);
		//
		sp_ReadType.setOnItemSelectedListener(new Spinner.OnItemSelectedListener() {
			@Override
			public void onItemSelected(AdapterView<?> arg0,
									   View arg1, int arg2, long arg3) {
				int selectItem = sp_ReadType
						.getSelectedItemPosition();
				if (PublicData._IsCommand6Cor6B.equals("6C")) {// 读6C标签
					tv_TitleTagCount.setText("Count");
					if (selectItem == 0) {
						_ReadType = 0;
						_NowReadParam = _NowAntennaNo + "|1";
						tv_TitleTagID.setText("EPC");
					} else if (selectItem == 1) {
						_ReadType = 1;
						_NowReadParam = _NowAntennaNo + "|1|2,0006";
						tv_TitleTagID.setText("TID");
					} else if (selectItem == 2) {
						_ReadType = 2;
						_NowReadParam = _NowAntennaNo
								+ "|1|3,000006";
						tv_TitleTagID.setText("UserData");
					} else if (selectItem == 3) {
						_ReadType = 3;
						_NowReadParam = _NowAntennaNo
								+ "|1|8,01";
						tv_TitleTagID.setText("EPC");
						tv_TitleTagCount.setText("T(C)");
					}else if (selectItem == 4) {
						_ReadType = 4;
						_NowReadParam = _NowAntennaNo
								+ "|1|7,01&4,000C03&3,000804&1,0300E000";
						tv_TitleTagID.setText("EPC");
						tv_TitleTagCount.setText("T(C)");
					}
				} else {
					tv_TitleTagCount.setText("Count");
					if (selectItem == 0) {
						_ReadType = 0;
						tv_TitleTagID.setText("EPC");
					} else if (selectItem == 1) {
						_ReadType = 1;
						tv_TitleTagID.setText("TID");
					} else if (selectItem == 2) {
						_ReadType = 2;
						tv_TitleTagID.setText("UserData");
					}
				}
			}

			@Override
			public void onNothingSelected(AdapterView<?> arg0) {
			}
		});
		//
		CLReader.HP_CONNECT.get(ConnID).myLog = this;
	}

	//刷新显示线程
	protected void Refush()
	{
		IsFlushList = true;
		// 刷新线程
		Helper_ThreadPool.ThreadPool_StartSingle(new Runnable() {
			@Override
			public void run() {
				while (IsFlushList) {
					try {
						sendMessage(MSG_RESULT_READ, null);
						Thread.sleep(1000); // 一秒钟刷新一次
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
				}
			}
		});

		Helper_ThreadPool.ThreadPool_StartSingle(new Runnable() { // 蜂鸣器发声
			@Override
			public void run() {
				while (IsFlushList) {
					synchronized (beep_Lock) {
						try {
							beep_Lock.wait();
						} catch (InterruptedException e) {
						}
					}
					if (IsFlushList) {
						toneGenerator
								.startTone(ToneGenerator.TONE_PROP_BEEP);
					}

				}
			}
		});
	}

	// 释放资源
	protected void Dispose() {
		IsFlushList = false;
		synchronized (beep_Lock) {
			beep_Lock.notifyAll();
		}
	}

	//显示列表
	protected void ShowList() {
		sa = new SimpleAdapter(this, GetData(), R.layout.epclist_item,
				new String[] { "EPC", "ReadCount" }, new int[] {
				R.id.EPCList_TagID, R.id.EPCList_ReadCount });
		listView.setAdapter(sa);
		listView.invalidate();
		if (lb_ReadTime != null) { // 刷新读取时间
			readTime++;
			lb_ReadTime.setText("Time:" + readTime / 1 + "S");
		}
		if (lb_ReadSpeed != null) { // 刷新读取速度
			speed = totalReadCount - lastReadCount;
			if (speed < 0)
				speed = 0;
			lastReadCount = totalReadCount;
			if (lb_ReadSpeed != null) {
				lb_ReadSpeed.setText("SP:" + speed + "T/S");
			}
		}
		if (lb_TagCount != null) { // 刷新标签总数
			lb_TagCount.setText("Total:" + hmList.size());
		}
	}

	// 获得更新数据源
	@SuppressWarnings({ "rawtypes", "unused" })
	protected List<Map<String, Object>> GetData() {
		List<Map<String, Object>> rt = new ArrayList<Map<String, Object>>();
		synchronized (hmList_Lock) {
			// if(hmList.size() > 0){ //
			Iterator iter = hmList.entrySet().iterator();
			while (iter.hasNext()) {
				Map.Entry entry = (Map.Entry) iter.next();
				String key = (String) entry.getKey();
				Tag_Model val = (Tag_Model) entry.getValue();
				Map<String, Object> map = new HashMap<String, Object>();
				if (_ReadType == 0) {
					map.put("EPC", val._EPC);
					map.put("ReadCount", val._TotalCount);
					rt.add(map);
				} else if (_ReadType == 1) {
					if(!val._TID.equals("")) {
						map.put("EPC", val._TID);
						map.put("ReadCount", val._TotalCount);
						rt.add(map);
					}
				} else {
					if(!val._UserData.equals("")) {
						map.put("EPC", val._UserData);
						map.put("ReadCount", val._TotalCount);
						rt.add(map);
					}
				}
			}
			// }
		}
		return rt;
	}

	// 保存数据源
	@SuppressWarnings({ "rawtypes", "unused" })
	protected boolean SaveData() {
		if (!bSaveResult) {
			return false;
		}

		//List<Map<String, Object>> rt = new ArrayList<Map<String, Object>>();
		synchronized (hmList_Lock) {
			// if(hmList.size() > 0){ //
			Iterator iter = hmList.entrySet().iterator();
			while (iter.hasNext()) {
				Map.Entry entry = (Map.Entry) iter.next();
				String key = (String) entry.getKey();
				Tag_Model val = (Tag_Model) entry.getValue();
				//Map<String, Object> map = new HashMap<String, Object>();

				if (_ReadType == 0) {
					write(val._EPC+",");
				} else if (_ReadType == 1) {
					write(val._TID+",");
				} else if (_ReadType == 3) {
					write(val._EPC+",");
				} else if (_ReadType == 4) {
					write(val._EPC+",");
				} else {
					write(val._UserData+",");
				}

				if (_ReadType == 3) {
//						float temp = UHFReader._Tag6C.EM_ConvertTemperature(val);
//						write(temp+"\r\n");
				} else if (_ReadType == 4) {
//						float temp = UHFReader._Tag6C.RFMicron_ConvertTemperature(val);
//						write(temp+"\r\n");
				} else {
					write(val._TotalCount+"\r\n");
				}

				//rt.add(map);
			}
		}
		//return rt;
		return true;
	}

	private void write(String content) {
		try {
			// 以追加的方式打开文件输出流
			FileOutputStream fileOut  = new FileOutputStream(FILE_NAME,true);
			// 写入数据
			fileOut.write(content.getBytes());
			// 关闭文件输出流
			fileOut.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// 创建
		super.onCreate(savedInstanceState);
		getWindow().setFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON,
				WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
		this.setContentView(R.layout.uhf_read);

		showCustomBar(getString(R.string.tv_Read_Title),
				getString(R.string.str_back), null,
				R.drawable.left, 0,
				new View.OnClickListener() {
					@Override
					public void onClick(View v) {
						Back(v);
					}
				},
				null
		);
	}

	@Override
	protected void onDestroy() {
		// 释放
		super.onDestroy();
	}

	@Override
	protected void onPause() {
		// 待机锁屏
		super.onPause();
		Dispose();
	}

	@Override
	protected void onResume() {
		// 待机恢复
		super.onResume();
		Init();
	}

	@Override
	public void onBackPressed() {
		Back(null);
	}

	@Override
	public void OutPutTags(Tag_Model model) {
		try {
			synchronized (hmList_Lock) {
				if (hmList.containsKey(model._EPC + model._TID)) {
					Tag_Model tModel = hmList.get(model._EPC + model._TID);
					tModel._TotalCount++;
					model._TotalCount = tModel._TotalCount;
					hmList.remove(model._EPC + model._TID);
					hmList.put(model._EPC + model._TID, model);
				} else {
					model._TotalCount = 1;
					hmList.put(model._EPC + model._TID, model);
				}
			}
			synchronized (beep_Lock) {
				beep_Lock.notify();
			}
			totalReadCount++;
		} catch (Exception ex) {
			Log.d("Debug", "Tags output exceptions:" + ex.getMessage());
		}
	}

	@Override
	public void WriteDebugMsg(String s) {
		// TODO Auto-generated method stub

	}

	@Override
	public void WriteLog(String s) {
		// TODO Auto-generated method stub

	}

	@Override
	public void PortConnecting(String s) {
		// TODO Auto-generated method stub

	}

	@Override
	public void PortClosing(String s) {
		// TODO Auto-generated method stub

	}

	@Override
	public void OutPutTagsOver() {
		// TODO Auto-generated method stub

	}

	@Override
	public void GPIControlMsg(int i, int j, int k) {
		// TODO Auto-generated method stub

	}

	@Override
	public void OutPutScanData(byte[] scandata) {
		// TODO Auto-generated method stub
	}
}
